require 'colorize'

#CLI Controller
class Bitprice::CLI

  attr_accessor :input

  def call
    details
    menu
  end

  def details
    puts "                                                        "
    puts "                                                        "
    puts "$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$".colorize(:green)
    puts "                                                        "
    puts " -------| Welcome to Bitprice! Version 0.1.0 |-------".colorize(:yellow)
    puts "Your #1 source for real time Cryptocurrency information".colorize(:yellow)
    puts "                   Top 100 Coins                              ".colorize(:yellow)
    puts "                                                        "
    puts "$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$".colorize(:green)
    puts "                                                                          "

    @listing = Bitprice::Listing.now
    @listing.each.with_index(1) do |crypto, i| 
      puts "#{i}." + "#{crypto.name}".colorize(:yellow) + " -" + "#{crypto.percent}".colorize(:red) + " |  " +  "$#{crypto.high}".colorize(:green) + " / " + "$#{crypto.low}".colorize(:green)
    end
    #@listing.clear
  end

  def menu

    puts "      "
    puts "--Bitprice Menu--".colorize(:cyan)
    puts "-Want to know more about a specific coin? Enter the associated number of any coin!"
    puts "-Automatically update market details? Type 'auto' for minute by minute updates!"
    puts "-Display the main list? Type 'list'"
    puts "-Done browsing Cryptocurrency markets? Type 'exit'."

    input = gets.strip.downcase 
    
    if input.to_i > 0
      info = @listing[input.to_i-1]
      puts "                  "
      puts "----- " + "#{info.name}".colorize(:cyan) + " -----"
      puts "-Ticker Name:".colorize(:magenta) + " #{info.ticker}"
      puts "-Last Price:".colorize(:green) + " $#{info.last_price}"
      puts "-Market Percentage:".colorize(:yellow) + " #{info.percent}"
      puts "-24 Hour High:".colorize(:red) +  " $#{info.high}"
      puts "-24 Hour Low:".colorize(:red) + " $#{info.low}"
      puts "-24 Hour Volume:".colorize(:cyan) + " $#{info.volume}"
      puts "-Number of Coins:".colorize(:yellow) + " #{info.numcoins}"
      puts "-Market Cap:".colorize(:green) + " #{info.marketcap}"
      puts "                  "
    elsif input == 'list'
      @listing.clear
      call
    elsif input == 'exit'
      puts "                  "
      puts "She cannot take any more of this, Captain!".colorize(:magenta)
      puts "                  "
      abort
    elsif input == 'auto'
      x = 0
      puts "                  "
      puts "--Auto-Update Enabled--".colorize(:cyan)
      puts "                  "
      sleep(60)
      @listing.clear
      call
    else
      puts "Bleep Bl00p..Invalid Response."
    end
  menu
end



end
